//PROGRAMA PARA EJECUTAR DESPACHO ECONMICO  
//SIN CONSIDERAR LAS PRDIDAS EN EL SISTEMA

function [mensaje]=despacho1(caso)
printf ("PROGRAMA PARA EL CLCULO DEL DESPACHO ECONMICO SIN PRDIDAS\n");
exec(caso);                          //Ejecucin y lectura de datos del sistema
[X]=gen;                             //Asignacin de los datos de los generadores
n=max(X(:,1));                       //Calculo del numero de generadores del sistema
X(:,2)=base*X(:,2);
X(:,3)=base*X(:,3);                  //Adaptacin de los parmetros con la potencia base
for i=1:n
 if (X(i,8)==0)                      //Verificacin de la ecuacin de costo incremental 
  a(i)=X(i,6);                       //de cada generador
 else
  a(i)=2*X(i,6);
 end
 b(i)=X(i,7);
 Pmin(i)=X(i,2);                     //Establecimiento de las potencias activas mxima y
 Pmax(i)=X(i,3);                     //mnima de generacin
end 
txt=['Potencia [MW]'];               //Lectura de la potencia demandada entrada por el usuario
sig=x_mdialog('Introduzca la potencia demandada por el sistema',txt,['']);
Pd=evstr(sig(1));
printf ("\n");                                         
condicion=1;k=0;d=0;
valor=zeros(1,n);                                      //Inicializacin de variables

if (Pd>sum(Pmax(:,1)))
 x_message(['Se ha superado el limite de potencia mxima'],['Aceptar']);
 condicion=0;
end                                                    //Validacin en caso de superar los 
if (Pd<sum(Pmin(:,1)))                                 //limites mximo y mnimo de generacin 
 x_message(['Se ha superado el limite de potencia mnima'],['Aceptar']);
 condicion=0;
end 

while (condicion==1)                    //Calculo del costo incremental mediante
 d=1;                                   //un ciclo
 suma=0;
 for i=1:n
  if valor(i)==0
   suma=1/a(i)+suma;                       
  end
 end
 A=inv(suma);                           //Calculo del costo incremental basado en los coeficientes
 suma=0;                                //a y b de la ecuacin de costos de cada generador
 for i=1:n
  if valor(i)==0
   suma=b(i)/a(i)+suma;
  end
 end
 B=A*suma;                              //Asignacin del costo incremental "lambda"
 lambda=A*Pd+B;
 for i=1:n
  if (valor(i)==0)
   P(i)=(lambda-b(i))/a(i);             //Asignacin de las potencias de generacin
  end                                   //segn el costo incremental del sistema 
 end
 for i=1:n
  if (P(i)>Pmax(i))                     //Validacin en caso de que la potencia asignada
   P(i)=Pmax(i);                        //sobrepase el lmite mximo del generador
   Pd=Pd-abs(Pmax(i));
   valor(i)=1;
  else 
   if (P(i)<Pmin(i))                    //Validacin en caso de que la potencia asignada
    P(i)=Pmin(i);                       //sobrepase el lmite mnimo del generador
    Pd=Pd-abs(Pmin(i));
    valor(i)=1;
   else
    valor(i)=0;                         //Valor se convierte en "1" en caso de existir violacin
   end                                  //de lmites de potencia, y en "0" en caso de no haberla
  end
 end
 condicion=max(valor);                  //Evaluacin de la condicin de finalizacin del ciclo
end 


if (d==1)                               //Impresin de los resultados en pantalla
 printf ("El costo incremental total del sistema es: %.4f\n",lambda);
 printf ("\nLas potencias despachadas por las barras de generacin son:\n");
 printf ("\n Barra   Potencia\n");
 printf ("\  No.      [MW]\n");
 for i=1:n
  printf ("  %d        %.1f\n",i,P(i));
 end 
end

mensaje='FIN DEL ANLISIS';
endfunction

//===========================================================================================
//===========================================================================================
//Programa para el clculo de Despacho econmico
//considerando las prdidas en el sistema de potencia

function [mensaje]=despacho2(caso)
printf ("PROGRAMA PARA EL CLCULO DEL DESPACHO ECONMICO CONSIDERANDO PRDIDAS\n");
exec(caso);                       //Ejecucin y lectura del archivo de datos del sistema
[X]=gen;
n=max(X(:,1));                    //Calculo del nmero de generadores
printf ("\n");
X(:,2)=base*X(:,2);               //Modificacin de los parmetros de potencia segun la potencia
X(:,3)=base*X(:,3);               //base del sistema
for i=1:n
 if (X(i,8)==0)
  a(i)=X(i,6);                    //Validacin de la ecuacin de costo de los generadores
 else
  a(i)=2*X(i,6);
 end
 b(i)=X(i,7);
 Pmin(i)=X(i,2);                  //Establecimiento de los lmites mximo y mnimo de potencia
 Pmax(i)=X(i,3);                  //de generacin del sistema
end 

B=coef;                           //Lectura de la potencia demandada por el sistema
txt=['Potencia [MW]'];            //entrada por el usuario
sig=x_mdialog('Introduzca la potencia demandada por el sistema',txt,['']);
Pd=evstr(sig(1));
Pd=Pd/base;                                          
printf ("\n");
B=factor*B;                       //Asignacin de la matriz de coeficientes B 
a=base*a;                         //Inicializacin de los parmetros usados por el programa 
aux1=0;aux2=0;
condicion=1;
algo=0;

while (condicion==1)              //Clculo del costo incremental bajo un ciclo
for i=1:n
 for l=1:n
  if (i==l)
   A(i,l)=a(i)/lambda+2*B(i,l);   //Calculo de la matriz de perdidas del sistema
  else
   A(i,l)=2*B(i,l);
  end
 end
end

for i=1:n
 C(i,1)=(1-2*B(i,n+1))-b(i)/lambda; 
end

P=inv(A)*C;                       //Clculo de la matriz de potencias asignadas 
suma1=0;
suma2=0;
for i=1:n
 for l=1:n                        //Clculo de las prdidas totales del sistema
  suma1=P(i,1)*B(i,l)*P(l,1)+suma1;
 end
 suma2=B(i,n+1)*P(i,1);
end
Pl=suma1+suma2+B(n+1,n+1);
algo=Pd+Pl-sum(P(:,1));           //Verificacin de la ecuacin de balance de potencia
if (abs(algo)<epsilon)
 condicion=0;                     //Verificacin de la condicin de finalizacin del ciclo
end
dlambda=((lambda-aux1)/(sum(P(:,1))-aux2))*(Pd+Pl-sum(P(:,1)));  //Calculo del diferencial "lambda"
aux1=lambda;
lambda=lambda+dlambda;            //Calculo del nuevo costo incremental "lambda" del sistema       
aux2=sum(P(:,1));
end

suma1=0;
for k=1:n
 suma1=0;
 for i=1:n
  suma1=P(i,1)*B(i,k);
 end
 suma1=2*suma1;
 fact(k)=suma1;
 fact(k)=1/(1-fact(k));
end 

printf ("El costo incremental total del sistema es: %.4f\n",lambda); 
printf ("\nLas potencias despachadas por las barras de generacin son:\n");
printf ("\n Barra   Potencia    Factor de\n");
printf ("\  No.      [MW]     penalizacin\n");
for i=1:n
 printf ("  %d        %.1f      %.4f\n",i,P(i)*base,fact(i));   //Impresin de datos en pantalla
end 
printf ("\n");
printf ("Las perdidas totales son: %.3f [MW]\n",Pl*base);
mensaje='FIN DEL ANLISIS';
endfunction
