
//FUNCIONES COMUNES A LOS TRES PROGRAMAS DE ANALISIS DE ESTABILIDAD
function [YL]=modificacion(Y,y)
 for p=1:n
  if (Tipo (p)<>3) then
   YL(p,p)=Y(p,p)+1/(j*G(p,3))+y(p);    //Esta funcin se encarga de acondicionar 
  else                                  //las variables de la Ybarra con la admitancia
   YL(p,p)=Y(p,p)+y(p);                 //del sistema bajo falla
  end
 end
 for p=1:n
  for q=1:n
   if (p<>q) then
    YL(p,q)=Y(p,q)/YL(p,p);
   end
  end
 end
endfunction

function [E,dd,Y]=fem(P,V,Q,Y)
 for i=1:n
  if (Tipo(i)<>3)then
   I(i)=(Pg(i)-j*Qg(i))/conj(V(i));       //Esta funcion calcula la fuerza electromotriz o
   E(i)=V(i)+j*G(i,3)*I(i);               //tensin inducida en el generador al momento de  
   dd(i)=atan(imag(E(i))/real(E(i)));     //iniciar el anlisis de estabilidad
  else
   y(i)=((-1)*P(i)+j*Q(i))/abs(V(i))^2;
  end
  Y(i,i)=Y(i,i)+y(i);
 end
endfunction 

function [V]=tension(YL,V,E)
 condicion4=1;kk=0;
 [aux7]=V;
 while (condicion4==1 & kk<25)            //Esta funcion calcula la tensin en las barras
  kk=kk+1;                                //del sistema segun el comportamiento de los 
  for p=1:n                               //generadores bajo falla
   if (p<>b)then                          //Observese que depende de la f.e.m inducida
    suma1=0;suma2=0;suma3=0;
    for q=1:(p-1)
     suma1=suma1+YL(p,q)*V(q);
    end
    for q=(p+1):n
     suma2=suma2+YL(p,q)*V(q);
    end 
    for i=1:n
     if (Tipo(p)<>3)
      if (i<>b) then
       if (Tipo(i)<>3) then
        suma3=suma3+(-1/(j*G(i,3)))*(1/(Y(p,p)+1/(j*G(i,3))))*E(i);
       end
      end
     end
    end
    V(p)=(-1)*(suma1+suma2+suma3);
    a=abs(V(p)-aux7(p));
    aux7(p)=V(p);
   end
  end 
  if (a<0.00001) then
   condicion4=0;
  end
 end  
endfunction

function [S]=potencia(V,E)
 for i=1:n
  if (Tipo(i)<>3) then                     //En esta funcion se calcula la potencia
   I(i)=(E(i)-V(i))*(1/(j*G(i,3)));        //compleja inducida en las barras de generacin
   S(i)=I(i)*conj(E(i));
  end
 end
endfunction

function [d1]=delta(dd,w,K2,dt)
 for i=1:n
  if (Tipo(i)<>3) then                     //Calculo del ngulo de estabilidad para cada 
   d1(i)=dd(i)+(w(i,1)-K2)*dt;             //una de las barras de generacin
  end
 end
endfunction

function [w1]=omega(w,Pe,Pg,dt)
 for i=1:n
  if (Tipo(i)<>3) then                             //Calculo de la velocidad durante el anlisis
   w1(i)=w(i)+((%pi*60)/G(i,2))*(Pg(i)-Pe(i))*dt;  //de estabilidad para cada una de las barras
  end                                              //de generacin
 end
endfunction

function [d1]=delta1(d1,w,w1,K2,dt)
 for i=1:n
  if (Tipo(i)<>3) then                             //Calculo del nuevo angulo de estabilidad
   d1(i)=d1(i)+((w(i)-K2+w1(i)-K2)/2)*dt;          //corregido
  end                                              //Funcion usada por el mtodo de Euler modificado
 end
endfunction 

function [w1]=omega1(w,w1,Pe,Pg,dt)
 for i=1:n
  if (Tipo(i)<>3) then                             //Calculo de la nueva velocidad de estabilidad
   a1=(w1(i)-w(i))/dt;                             //corregida
   w1(i)=w(i)+((a1+((%pi*60)/G(i,2))*(Pg(i)-Pe(i)))/2)*dt; //Usado por el mtodo de Euler modificado
  end
 end
endfunction

function [Y]=nuevaY(Y,b,p)
 Y(b,b)=Y(b,b)-Y(b,p);
 Y(p,p)=Y(p,p)-Y(p,b);                             //Calcula la Ybarra resultante al abrirse los
 Y(b,p)=0;                                         //interruptores ubicados en los extremos de la
 Y(p,b)=0;                                         //lnea bajo falla
endfunction

function []=escribirest(dt,Tipo,n,Tmax,velocidad1,angulo)
 printf ("\n Resultados de la simulacin de estabilidad\n");    //Esta funcin escribe los resultados
 t=dt;                                                          //en pantalla
 conta=1;
 printf ("\n Velocidad de referencia: %.2f [rad/s]\n",2*%pi*f);
 printf ("\n Los valores de velocidad estn dados en [p.u] respecto a la de referencia\n");
 printf ("\n Los valores de Angulo estn dados en []\n");
 printf ("\n Tiempo    ");
 for i=1:n
  if (Tipo(i)<>3)
   printf ("   Maquina %d     ",i);
  end
 end
 printf ("\n");
 printf ("  [s]  ");
 for i=1:n
  if (Tipo(i)<>3)
   printf ("  Velocidad Angulo");
  end
 end
 printf ("\n");
 while (t<Tmax)
  printf (" %.3f    ",t);
  for i=1:n
   if (Tipo (i)<>3) then
    printf ("%.3f  %.4f     ",velocidad1(conta,i),angulo(conta,i));
   end
  end
  printf("\n");
  t=t+dt;
  conta=conta+1;
 end 
endfunction  

function []=graficarest(dt,Tmax,n,tam1,velocidad1,angulo)
 t=0+dt:dt:Tmax;
 xdel();
 xdel();
 xinit();
 for i=1:n
  if (Tipo(i)<>3)   
   xset("color",2);                                            //Esta funcin se encarga de elaborar las graficas
   xname('Grafica de Velocidad vs. Tiempo');                   //de velocidad vs. Tiempo y Angulo vs. Tiempo para 
   subplot(tam1,1,i);                                          //cada una de las barras de generacin involucradas
   plot2d(t,velocidad1(:,i),style=5);                          //en el anlisis de estabilidad
   xtitle(['Velocidad Maquina'],'Tiempo [s]','Velocidad [p.u]');
  end
 end 
 xinit();
 for i=1:n
  if (Tipo(i)<>3)
   xset("color",6);   
   xname('Grafica de Angulo vs. Tiempo');
   subplot(tam1,1,i);
   plot2d(t,angulo(:,i),style=3);
   xtitle(['Angulo Maquina'],'Tiempo [s]','Angulo []');
  end
 end 
 printf ("\n TIEMPO MAXIMO DE ANALISIS: %0.3f SEGUNDOS\n",Tmax);
endfunction

//=============================================================================================
//=============================================================================================
//Programa para el anlisis de estabilidad en Sistemas de
//Potencia utilizando el mtodo de Euler Modificado

function [mensaje]=euler_mod(a);
Y=Ybarra(a);
newton_raphson(a);                  //Calculo de las condiciones iniciales del sistema a traves
exec(a);                            //del anlisis de flujo de carga por Newton-Raphson 
[F]=fscanfMat ('Res_fluj_carg');    //Lectura de los resultados arrojados por el flujo de carga
[G]=genest;
n=max(F(:,1));
[h]=F(:,1);
[v]=F(:,2);           
[d]=F(:,3);                         //Asignacin de varibles globales a cada una de las matrices   
[Pg]=F(:,4)/base;                   //usadas por el clculo de estabilidad
[Qg]=F(:,5)/base;
[Pd]=F(:,6)/base;
[Qd]=F(:,7)/base;
Tipo=barras(:,8);
for i=1:n
 P(i)=Pg(i)-Pd(i);                  //Calculo de las potencias activa y reactiva netas en cada barra
 Q(i)=Qg(i)-Qd(i);
end
      
for i=1:n
 d(i)=(d(i)*2*%pi)/360;             //Cambio del angulo de grados a radianes
end

for i=1:n                           //Calculo de la tension como variable compleja
 v(i)=v(i)*cos(d(i));               //parte real       
 d(i)=v(i)*sin(d(i));               //parte imaginaria  
 V(i)=v(i)+j*d(i);
end

for i=1:n
 y(i)=(Pd(i)-j*Qd(i))/(v(i)^2+d(i)^2); //Calculo de la admitancia equivalente de los generadores
end 

[YL]=modificacion(Y,y);             //Modificacin del sistema bajo falla

[E,dd,Y]=fem(P,V,Q,Y);              //Calculo de las tensiones de generador

t=0;condicion=1;k=0;J=0;
K2=2*%pi*f;
w=ones(n,1);
w=w*2*%pi*f;                        //Inicializacin de variables propias del algoritmo
aux31=V(b);
V(b)=0;
[tam1,tam2]=size(G);
angulo=zeros(Tmax/dt,tam1);
velocidad1=zeros(Tmax/dt,tam1);
cont=1;
printf ("\n ANALISIS DE ESTABILIDAD A TRAVES DEL METODO DE EULER MODIFICADO\n");

while (condicion==1)                //Algoritmo de Euler modificado a travs de un ciclo
 V=tension(YL,V,E);
 S=potencia(V,E);                   //Calculo de tensiones y potencias iniciales para cada
 Pe=real(S);                        //paso de tiempo
 if (J==0) then
  d1=delta(dd,w,K2,dt);             //Primera condicion de estabilidad, calculo inicial de 
  w1=omega(w,Pe,Pg,dt);             //angulo y velocidad sin correccin
  for i=1:n
   if (Tipo(i)<>3)    
    e1(i)=abs(E(i))*cos(d1(i));     //Calculo preliminar de la tension
    f1(i)=abs(E(i))*sin(d1(i));
    E(i)=e1(i)+j*f1(i);
   end 
  end 
  J=1;
  V=tension(YL,V,E);                //Calculo intermedio de tensiones y potencias desarrolladas
  S=potencia(V,E);
  Pe=real(S);
 else
  if (J==1) then
   d1=delta1(dd,w,w1,K2,dt);        //Segunda condicion de estabilidad, calculo de angulo y
   w1=omega1(w,w1,Pe,Pg,dt);        //velocidad corregidos
   dd=d1;  
   w=w1;
   for i=1:n
    if (Tipo(i)<>3) 
     e1(i)=abs(E(i))*cos(d1(i));    //Calculo preliminar de la tension
     f1(i)=abs(E(i))*sin(d1(i));
     E(i)=e1(i)+j*f1(i);
    end
   end 
   J=2;
   V=tension(YL,V,E);               //Calculo intermedio de tensiones y potencias desarrolladas
   S=potencia(V,E);
   Pe=real(S);
  else
   if (t>=Tmax) then                //Verificacin de la condicin para finalizar el anlisis
    condicion=0;
   else
    t=t+dt;
    for i=1:n
     if (Tipo (i)<>3)
      velocidad1(cont,i)=w1(i)/(2*%pi*f);  //Almacenamiento de los vectores de angulo y velocidad
      angulo(cont,i)=d1(i)*360/%pi;        //para cada una de las mquinas de generacin del sistema
     end
    end 
    cont=cont+1;
    if (t==Sw) then
     printf("\n LIBRAMIENTO DE LA FALLA EN %0.3f SEGUNDOS\n",Sw);
     disp('EJECUTANDO MODIFICACION DEL SISTEMA');
     Y(b,b1)=0;
     Y(b1,b)=0;
     Y(b,b)=Y(b,b)-Y(b,b1);                //Modificacin del sistema al momento de librar la falla
     Y(b1,b1)=Y(b1,b1)-Y(b1,b);
     [YL]=modificacion(Y,y);
     J=0;
     V(b)=aux31;
     V=tension(YL,V,E);                    //Calculo de las nuevas tensiones y potencias al momento
     S=potencia(V,E);                      //del libramiento de falla
     Pe=real(S);
    else
     d1=delta(dd,w,K2,dt);
     w1=omega(w,Pe,Pg,dt);                 //Calculo de velocidad y angulo en caso de no librar la
     for i=1:n                             //falla
      if (Tipo(i)<>3) 
       e1(i)=abs(E(i))*cos(d1(i));
       f1(i)=abs(E(i))*sin(d1(i));         //Calculo preliminar de la tension
       E(i)=e1(i)+j*f1(i);
      end
     end 
     V=tension(YL,V,E);
     S=potencia(V,E);                      //Calculo intermedio de tensiones y potencias desarrolladas
     Pe=real(S);
     J=1;
    end
   end
  end
 end
 for i=1:n
  if (Tipo(i)<>3) then
   ww(i)=w1(i)/(2*%pi*f);                 //Cambio de la velocidad a valores en [p.u]
   dde(i)=d1(i)*360/%pi;                  //Cambio del angulo a valores en grados 
  end
 end
end
escribirest(dt,Tipo,n,Tmax,velocidad1,angulo); //Invocacin de las funciones para la salida de datos
graficarest(dt,Tmax,n,tam1,velocidad1,angulo); 
mensaje='FIN DEL ANALISIS DE ESTABILIDAD';
endfunction

//=============================================================================================
//=============================================================================================
//Programa para el anlisis de estabilidad en Sistemas de
//Potencia utilizando el mtodo de Runge-Kutta de 4 orden

function [mensaje]=runge_kutta(a)
Y=Ybarra(a);
newton_raphson(a);                         //Calculo de las condiciones iniciales del sistema a traves
exec(a);                                   //del anlisis de flujo de carga por Newton-Raphson 
[F]=fscanfMat ('Res_fluj_carg');           //Lectura de los resultados arrojados por el flujo de carga
[G]=genest;
n=max(F(:,1));
[h]=F(:,1);
[v]=F(:,2);            
[d]=F(:,3);                                //Asignacin de datos a los vectores iniciales
[Pg]=F(:,4)/base;
[Qg]=F(:,5)/base;
[Pd]=F(:,6)/base;
[Qd]=F(:,7)/base;
Tipo=barras(:,8);

for i=1:n
 P(i)=Pg(i)-Pd(i);                         //Calculo de las potencias activa y reactiva netas
 Q(i)=Qg(i)-Qd(i);                         //en cada barra del sistema
end

for i=1:n
 d(i)=(d(i)*2*%pi)/360;                    //Cambio del angulo de cada barra de grados a radianes
end

for i=1:n                                  //Calculo de la tensin por barra como variable compleja
 v(i)=v(i)*cos(d(i));                      //parte real
 d(i)=v(i)*sin(d(i));                      //parte imaginaria
 V(i)=v(i)+j*d(i); 
end

for i=1:n
 y(i)=(Pd(i)-j*Qd(i))/(v(i)^2+d(i)^2);     //Calculo de la admitancia equivalente de los generadores 
end 

[YL]=modificacion(Y,y);                    //Modificacin del sistema bajo falla

[E,dd,Y]=fem(P,V,Q,Y);                     //Calculo de la tensin de los generadores

t=0;condicion=1;
w=ones(n,1);
w=w*2*%pi*f;
o=1;
aux=V(b);
V(b)=0;                                    //Inicializacin de varibles propias del algoritmo
V=tension(YL,V,E);
S=potencia(V,E);
Pe=real(S);
[tam1,tam2]=size(G);
angulo=zeros(Tmax/dt,tam1);
velocidad1=zeros(Tmax/dt,tam1);
cont=1;
printf ("\n ANALISIS DE ESTABILIDAD A TRAVES DEL METODO RUNGE KUTTA DE 4 ORDEN\n");

while (condicion==1)                        //Algorimo de Runge-Kutta a traves de ciclos
 for i=1:n
  if (Tipo(i)<>3) then                      //Condicin valida para las barras de generacin
   K1(i)=(w(i)-2*%pi*f)*dt;
   L1(i)=(%pi*f/G(i,2))*(Pg(i)-Pe(i))*dt;   //Calculo de los factores de estabilidad L1 y K1
   e(i)=abs(E(i))*cos(d(i)+K1(i)/2);        //cambio de velocidad y angulo en el tiempo respectivamente
   ff(i)=abs(E(i))*sin(d(i)+K1(i)/2);       //conforman el primer termino de la serie de 4
   E(i)=e(i)+j*ff(i);                       //Calculo de la tensin compleja desarrollada en las maquinas
  end
 end
 V=tension(YL,V,E);
 S=potencia(V,E);                           //Calculo de las tensiones y potencias por barra
 Pe=real(S);
 for i=1:n
  if (Tipo(i)<>3) then
   K2(i)=(w(i)+L1(i)/2-2*%pi*f)*dt;         //Calculo de los factores de estabilidad L2 y K2 
   L2(i)=(%pi*f/G(i,2))*(Pg(i)-Pe(i))*dt;   //idem caso anterior
   e(i)=abs(E(i))*cos(d(i)+K2(i)/2);
   ff(i)=abs(E(i))*sin(d(i)+K2(i)/2);       //conforman el segundo termino de la serie de 4
   E(i)=e(i)+j*ff(i);
  end
 end
 V=tension(YL,V,E);
 S=potencia(V,E);                           //Calculo de las tensiones y potencias por barra
 Pe=real(S);
 for i=1:n
  if (Tipo(i)<>3) then
   K3(i)=(w(i)+L2(i)/2-2*%pi*f)*dt;         //Calculo de los factores de estabilidad L3 y K3 
   L3(i)=(%pi*f/G(i,2))*(Pg(i)-Pe(i))*dt;   //idem caso anterior
   e(i)=abs(E(i))*cos(d(i)+K3(i));
   ff(i)=abs(E(i))*sin(d(i)+K3(i));         //conforman el tercer termino de la serie de 4
   E(i)=e(i)+j*ff(i);
  end
 end
 V=tension(YL,V,E);
 S=potencia(V,E);                           //Calculo de las tensiones y potencias por barra
 Pe=real(S);
 for i=1:n
  if (Tipo(i)<>3) then
   K4(i)=(w(i)+L3(i)-2*%pi*f)*dt;           //Calculo de los factores de estabilidad L4 y K4
   L4(i)=(%pi*f/G(i,2))*(Pg(i)-Pe(i))*dt;   //conforman el cuarto termino de la serie de 4
  end
 end
 
 for i=1:n
  if (Tipo(i)<>3) then
   dd(i)=(1/6)*(K1(i)+2*K2(i)+2*K3(i)+K4(i)); 
   dw(i)=(1/6)*(L1(i)+2*L2(i)+2*L3(i)+L4(i));  
   d(i)=d(i)+dd(i);                           //Calculo del angulo y velocidad desarrollados
   w(i)=w(i)+dw(i);                           //en cada generador en el tiempo
   e(i)=abs(E(i))*cos(d(i));
   ff(i)=abs(E(i))*sin(d(i));
   E(i)=e(i)+j*ff(i);                         //asignacin de la nueva tensin compleja en los
  end                                         //generadores
 end
 
 V=tension(YL,V,E);        
 S=potencia(V,E);                             //Calculo de las tensiones y potencias por barra 
 Pe=real(S);
 for i=1:n
  if (Tipo(i)<>3) then
   ww(i)=w(i)/(2*%pi*f);                      //Cambio de los valores de velocidad a [p.u]
   dde(i)=d(i)*360/%pi;                       //Cambio de los valores de angulo a grados
  end
 end
 t=t+dt;                                      //Avance del paso de tiempo
 for i=1:n
  if (Tipo (i)<>3)
   velocidad1(cont,i)=w(i)/(2*%pi*f);         //Almacenamiento de los vectores de velocidad y 
   angulo(cont,i)=d(i)*360/%pi;               //angulo
  end
 end 
 cont=cont+1;
 if (t>Tmax) then                             //Revisin de la condicin de finalizacin del 
  condicion=0;                                //anlisis de estabilidad
 end
 if (t==Sw) then
  printf ("\n LIBRAMIENTO DE FALLA EN %.3f SEGUNDOS\n",Sw);
  disp ('EJECUTANDO MODIFICACION DEL SISTEMA');
  [Y]=nuevaY(Y,b,b1);
  [YL]=modificacion(Y,y);
  V(b)=aux;                                   //Modificacin del sistema en caso de libramiento de falla
  V=tension(YL,V,E);
  S=potencia(V,E);
  Pe=real(S);
 end
end 

escribirest(dt,Tipo,n,Tmax,velocidad1,angulo);  //Invocacin de las funciones para la salida de datos
graficarest(dt,Tmax,n,tam1,velocidad1,angulo); 
mensaje='FIN DEL ANALISIS';
endfunction
 
//========================================================================================= 
//=========================================================================================

//Programa para el calculo de estabilidad en Sistemas de
//Potencia a traves del metodo trapezoidal o paso a paso

function [mensaje]=trapezoidal(a)
Y=Ybarra(a);
newton_raphson(a);                         //Calculo de las condiciones iniciales del sistema a traves
exec(a);                                   //del anlisis de flujo de carga por Newton-Raphson 
[F]=fscanfMat ('Res_fluj_carg');           //Lectura de los resultados arrojados por el flujo de carga
[G]=genest;
n=max(F(:,1));
[h]=F(:,1);
[v]=F(:,2);
[d]=F(:,3);                                //Asignacin de datos a los vectores iniciales
[Pg]=F(:,4)/base;
[Qg]=F(:,5)/base;
[Pd]=F(:,6)/base;
[Qd]=F(:,7)/base;
Tipo=barras(:,8);

for i=1:n
 P(i)=Pg(i)-Pd(i);                        //Calculo de las potencias activa y reactiva netas
 Q(i)=Qg(i)-Qd(i);                        //por barra
end

for i=1:n
 d(i)=(d(i)*2*%pi)/360;                   
end

for i=1:n                                 //Calculo de la tensin por barra como variable compleja
 v(i)=v(i)*cos(d(i));                     //parte real
 d(i)=v(i)*sin(d(i));                     //parte imaginaria
 V(i)=v(i)+j*d(i);
end

for i=1:n
 y(i)=(Pd(i)-j*Qd(i))/(v(i)^2+d(i)^2);    //Calculo de la admitancia equivalente de los generadores 
end 

[YL]=modificacion(Y,y);                   //Modificacin del sistema bajo falla

[E,dd,Y]=fem(P,V,Q,Y);                    //Calculo de la tensin en los generadores (f.e.m)

Da=0;wo=2*%pi*f;
t=0;condicion=1;k=0;J=0;
w=ones(n,1);
w=w*2*%pi*f;
aux=V(b);
V(b)=0;
V=tension(YL,V,E);                        //Inicializacin de las variables propias del algoritmo
S=potencia(V,E);
Pe=real(S);
[tam1,tam2]=size(G);
angulo=zeros(Tmax/dt,tam1);
velocidad1=zeros(Tmax/dt,tam1);
cont=1;
printf ("\n ANALISIS DE ESTABILIDAD A TRAVES DEL METODO TRAPEZOIDAL\n");

while (condicion==1)                      //Mtodo trapezoidal a travs de ciclos
 for i=1:n
  if (Tipo(i)<>3) then                    //Calculo exclusivo para las barras generadoras
   B=dt/(2*(G(i,2)/(%pi*f))+dt*Da);
   WC=(1-2*B*Da)*w(i)+B*(Pg(i)-Pe(i))+2*Da*wo;
   WX=B;                                  //Calculo del cambio de velocidad en los generadores 
   w(i)=WC+WX*(Pg(i)-Pe(i));
   AC=d(i)+(w(i)-2*wo)*(dt/2);            //Calculo del cambio de angulo de tension en los generadores
   AX=dt/2;
   d(i)=AC+AX*w(i);
   e1(i)=abs(E(i))*cos(d(i));
   f1(i)=abs(E(i))*sin(d(i));             //Calculo de la tensin en los generadores como variable
   E(i)=e1(i)+j*f1(i);                    //compleja
  end
 end 
 V=tension(YL,V,E);
 S=potencia(V,E);                         //Calculo de las tensiones y potencias en las barras
 Pe=real(S);                              //generadoras
 if (t>=Tmax) then 
  condicion=0;                            //Verificacin de la condicin de finalizacin del ciclo
 else
  t=t+dt;                                 //Avance del paso de tiempo 
  for i=1:n
   if (Tipo (i)<>3)
    velocidad1(cont,i)=w(i)/(2*%pi*f);    //Almacenamiento de los vectores de velocidad y ngulo
    angulo(cont,i)=d(i)*360/%pi;
   end
  end 
  cont=cont+1;
 end
 if (t==Sw) then
  printf ("\n LIBRAMIENTO DE FALLA EN %.3f SEGUNDOS\n",Sw);
  disp ('EJECUTANDO MODIFICACION DEL SISTEMA');
  [Y]=nuevaY(Y,b,b1);
  [YL]=modificacion(Y,y);                  //Modificacin del sistema en caso de libramiento de falla
  V(b)=aux;        
  V=tension(YL,V,E);
  S=potencia(V,E);                         //Calculo de las tensiones y potencias de posfalla
  Pe=real(S);
 end
 for i=1:n
  if (Tipo(i)<>3) then
   ww(i)=w(i)/(2*%pi*f);                   //Cambio de los valores de velocidad a [p.u]
   dde(i)=d(i)*360/%pi;                    //Cambio de los valores de angulo a grados
  end
 end
end

escribirest(dt,Tipo,n,Tmax,velocidad1,angulo);   //Invocacin de las funciones para la salida de datos
graficarest(dt,Tmax,n,tam1,velocidad1,angulo); 
mensaje='FIN DEL ANALISIS';
endfunction 
 
 

 


