
//Funciones auxiliares usadas por los programas que realizan flujo de carga

function [y,Pg,Qg,Pd,Qd,V,delta,Tipo]=asignacion1(barras,ramas)
 [tam1,tam2]=size(ramas);
 for i=1:tam1
  y(ramas(i,1),ramas(i,2))=ramas(i,5);        //Esta funcin se encarga de asignar los valores
  y(ramas(i,2),ramas(i,1))=ramas(i,5);        //extrados de las tablas de datos a cada uno de 
 end                                          //los vectores usados en el algoritmo, como por 
 [Pg]=barras(:,2);      //Asignacin de potencia activa generada por barra
 [Qg]=barras(:,3);      //Asignacin de potencia reactiva generada por barra
 [Pd]=barras(:,4);      //Asignacin de potencia activa consumida por barra
 [Qd]=barras(:,5);      //Asignacin de potencia reactiva consumida por barra 
 [V]=barras(:,6);       //Asignacin de la magnitud de tensin por barra
 [delta]=barras(:,7);   //Asignacin del ngulo de tensin por barra  
 [Tipo]=barras(:,8);    //Asignacin del tipo de Barra: compensacin, generacin o carga
endfunction

function [Pl,Q,Vesp,Qmax,Qmin]=asignacion2(n,Pg,Qg,Pd,Qd,gen)
 Pl=zeros(n,1);
 Q=zeros(n,1);
 for i=1:n                               //En esta funcin se asignan los valores netos de 
  Pl(i)=Pg(i)-Pd(i);                     //potencia activa y reactiva con los que opera cada
  Q(i)=Qg(i)-Qd(i);                      //una de las barras del sistema
 end 
 Vesp=zeros(n,1);
 Vesp(gen(:,1))=gen(:,9);      //Asignacin de la magnitud de tensin especificada por barra
 Qmax(gen(:,1))=gen(:,4);      //Asignacin de las potencia reactiva mxima y mnima generada
 Qmin(gen(:,1))=gen(:,5);      //por barra
endfunction

function [R]=reactiva ()
 for m=1:i-1                              //Esta funcin calcula la potencia reactiva por barra
  Suma1=Y(i,m)*V(m)+Suma1;                //segn los parmetros de red y tensiones del sistema
 end                                      //usada por el algoritmo de Gauss-Seidel
 for m=i:n
  Suma2=Y(i,m)*aux1(m)+Suma2;
 end
 R=(-1)*(imag (conj(aux1(i))*(Suma1+Suma2)));
endfunction

function [T]=Tension ()
 for m=1:i-1                              //Esta funcin calcula el valor complejo de la tensin 
  Suma1=Y(i,m)*V(m)+Suma1;                //segn los parmetros de red y las potencias activa y 
 end                                      //reactiva del sistema
 for m=i+1:n                              //usada por el algoritmo de Gauss-Seidel
  Suma2=Y(i,m)*aux1(m)+Suma2;
 end 
 T=(((Pl(i)-j*Q(i))/conj (aux1(i)))-Suma1-Suma2)/Y(i,i);
endfunction

function [Vmag,Vang]=escribir1 (n,V,Pg,Qg,Pd,Qd,k)
 printf ("\n");
 printf ("Los resultados son los siguientes:\n\n");                        //Esta funcin imprime
 printf ("Numero de iteraciones: %d\n\n",k);                               //los resultados del flujo
 printf ("                           Generacion         Carga\n");         //de carga en pantalla
 printf ("Barra  Tension  Angulo  Activa  Reactiva  Activa  Reactiva\n");
 Vmag=zeros(n,1);
 Vang=zeros(n,1);
 for (i=1:n)
  Vmag(i)=abs (V(i));
  Vang(i)=(atan(imag(V(i))/real (V(i))))*360/(2*%pi);
  if (Vang(i)<0)
   printf("  %d    %.4f   %.3f  %.4f  %.4f    %.4f  %.4f\n",i,Vmag(i),Vang(i),Pg(i),Qg(i),Pd(i),Qd(i));
  else 
   printf("  %d    %.4f   %.4f  %.4f  %.4f    %.4f  %.4f\n",i,Vmag(i),Vang(i),Pg(i),Qg(i),Pd(i),Qd(i));
  end 
 end
endfunction

function [activ,reactiv]=escribir2(n,V,Y,y,base,j)
 for i=1:n
  e(i)=V(i);
 end 
 printf ("\nEl flujo de carga en las lineas es el siguiente:\n\n");     //Esta funcin imprime en pantalla
 printf ("      Barra          Flujo en las lneas\n");                 //el flujo de carga en las lneas
 printf ("partida   llegada    Megawatts   Megavars\n");                //segn la distribucin tensiones
 for i=1:n                                                              //halladas al finalizar la ejecucin
  for l=1:n                                                             //de los algoritmos
   if (i<>l) then
    if (Y(i,l)<>0) then
     S(i,l)=conj(e(i))*(e(i)-e(l))*Y(i,l)*(-1)+conj(e(i))*e(i)*(j*y(i,l));
     activ(i,l)=real(S(i,l));
     reactiv(i,l)=(-1)*imag(S(i,l));
     if (activ(i,l)<0)
      if (reactiv(i,l)<0)
       printf ("   %d         %d       %.4f    %.4f\n",i,l,activ(i,l)*base,reactiv(i,l)*base);
      else
       printf ("   %d         %d       %.4f     %.4f\n",i,l,activ(i,l)*base,reactiv(i,l)*base);
      end
     else 
      if (reactiv(i,l)<0)
       printf ("   %d         %d        %.4f    %.4f\n",i,l,activ(i,l)*base,reactiv(i,l)*base);
      else
       printf ("   %d         %d        %.4f     %.4f\n",i,l,activ(i,l)*base,reactiv(i,l)*base);
      end 
     end 
    end
   end
  end
 end 
endfunction

function [perd]=perdidas(n,Y,activ,base)
 perd=0;
 for i=1:n                                             //Esta funcin calcula las prdidas del     
  for l=i:n                                            //sistema segn los resultados del flujo
   if (Y(i,l)<>0)                                      //de carga en las lneas
    perd=abs (abs(activ(i,l))-abs(activ(l,i)))+perd;
   end
  end 
 end
 printf ("\nLas prdidas totales del sistema son: %.4f [MW]\n",perd*base);
endfunction 

function []=graficas(n,Vmag,Vang)                     //Esta funcin se encarga de graficar la
 xdel();xdel();
 xbasr (0);                                           //magnitud y ngulo de la tensin por barra
 xset("color",3);                                     //segn los resultados del flujo de carga
 xname('Grafica del nivel de tensin');
 x=[1:1:n]';
 plot2d3([],[Vmag(x)],style=5);
 xtitle (['Nivel de tensin por barra del sistema'],'No. de Barra','Tensin [p.u]');
 xinit();
 xbasr (0);
 xset("color",3);
 xname('Grafica del angulo de tensin');
 x=[1:1:n]';
 plot2d3(x,[Vang(x)],style=5);
 xtitle (['Angulo de la tensin por barra del sistema'],'No. de Barra','Angulo []');
endfunction 

function [arch]=archivo(n,Vmag,Vang,Pg,Qg,Pd,Qd)
 [i]=(1:1:n);                                          //Esta funcin guarda los resultados del 
 resultado=[i' Vmag Vang Pg Qg Pd Qd];                 //anlisis de flujo de carga en un archivo
 arch=file('open','Res_fluj_carg','unknown');          //El archivo se actualiza cada vez que se 
 file('rewind',arch);                                  //ejecuta cualquiera de los programas de 
 write(arch,resultado);                                //anlisis
 file('close',arch);
endfunction 

//====================================================================================================
//====================================================================================================
  
//Programa que calcula el flujo de carga a travs del mtodo 
//de Gauss-Seidel (incluye factor de aceleracin)

function [mensaje]=gauss_seidel(a)
clear u;
Y=Ybarra(a);
exec(a);
n=max(barras(:,1));
[y,Pg,Qg,Pd,Qd,V,delta,Tipo]=asignacion1(barras,ramas);    //Invocacin de las funciones auxiliares
[Pl,Q,Vesp,Qmax,Qmin]=asignacion2(n,Pg,Qg,Pd,Qd,gen);
k=0; dVmax=0; 
dVmax=Epsilon+1;Suma1=0;Suma2=0;Suma5=0;Suma6=0;
[aux1]=V;

printf ("\n");
printf ("CALCULO DE FLUJO DE CARGA POR MEDIO DEL METODO GAUSS-SEIDEL\n\n");
printf ("Sistema de %d barras\n",n);

while ((abs(dVmax)>=Epsilon))                //Ejecucin del algoritmo de Gauss-Seidel mediante ciclos
 k=k+1;                                //k es el contador de las iteraciones                                     
 if k==1
  dVmax=0.1;                           //dVmax es la variacin mxima de tensin entre iteraciones
 end 
 aux1=V;
 for i=1:n
  select(Tipo(i))                      //Segn el tipo de barra se calcula la tensin y potencia reactiva 
   case (2)then                        // (2) si es una barra de generacin
    V(i)=Vesp(i);
    Q(i)=reactiva();
    if Q(i)<=Qmax(i)                   //Verificacin de los niveles mximo y mnimo de potencia reactiva
     if Q(i)>=Qmin(i)
      V(i)=Tension();
      V(i)=Vesp(i)/abs(V(i)); 
     else
      Q(i)=Qmin(i);
      V(i)=Tension();
     end
    else
     Q(i)=Qmax(i);
     V(i)=Tension(i);
    end
    dV(i)=V(i)-aux1(i);
    if (abs(dV(i))<abs(dVmax))          //Verificacin de los cambios de tensin por barra e iteracin
     dVmax=dV(i);
     V(i)=aux1(i)+alfa*(V(i)-aux1(i));  // inclusin del factor de aceleracin "alfa"
    else
     V(i)=aux1(i)+alfa*(V(i)-aux1(i));
    end
    
   case (3)then                         // (3) si es una barra de carga
    V(i)=Tension();
    dV(i)=V(i)-aux1(i);
    if (abs(dV(i))<abs(dVmax))
     dVmax=dV(i);
     V(i)=aux1(i)+alfa*(V(i)-aux1(i));  // inclusin del factor de aceleracin "alfa"
    else
     V(i)=aux1(i)+alfa*(V(i)-aux1(i));
    end 
  end
 end 
end


for (i=1:n)
  Vmag(i)=real(V(i));                   //Adaptacin del vector complejo de tensin 
  Vang(i)=imag(V(i));
end

Q=zeros (n,1);

for i=1:n                              //Clculo de la potencia reactiva segn los parmetros  
 if (Tipo(i)==1) then                  //y las tensiones de red
  for l=1:n
   Q(i)=Vang(i)*(Vmag(l)*real(Y(i,l))+Vang(l)*(-1)*imag(Y(i,l)))-Vmag(i)*(Vang(l)*real(Y(i,l))-Vmag(l)*(-1)*imag(Y(i,l)))+Q(i);
  end
 end
end

for i=1:n
 Suma5=0;Suma6=0;
 if (Tipo(i)==1)
  for t=i:i-1
   Suma5=Y(i,t)*V(t)+Suma5;
  end 
  for t=i:n
   Suma6=Y(i,t)*aux1(t)+Suma6;
  end
  Pl(i)=real (conj (V(i))*(Suma5+Suma6));
 end
end 

for i=1:n
 if (Tipo(i)==1)
  Pg(i)=Pl(i);
  Qg(i)=Q(i);
 end 
end 

[Vmag,Vang]=escribir1 (n,V,Pg,Qg,Pd,Qd,k);
[activ,reactiv]=escribir2(n,V,Y,y,base,j);          //Invocacin de las funciones para la impresin,
[perd]=perdidas(n,Y,activ,base);                    //graficacin y almacenamiento de los resultados
graficas(n,Vmag,Vang); 
[arch]=archivo(n,Vmag,Vang,Pg,Qg,Pd,Qd);
mensaje='FIN DEL ANLISIS';
endfunction 
 
//====================================================================================================
//====================================================================================================
  
//Programa que calcula el flujo de carga a travs del mtodo 
//de Newton-Raphson (completo)

function [mensaje]=newton_raphson(a)
clear u;
Y=Ybarra(a);
exec(a);
n=max(barras(:,1));
[y,Pg,Qg,Pd,Qd,V,delta,Tipo]=asignacion1(barras,ramas);
[Pl,Ql,Vesp,Qmax,Qmin]=asignacion2(n,Pg,Qg,Pd,Qd,gen);

for i=1:n
 d(i)=V(i)*sin(delta(i)); //Parte imaginaria de la tension
 V(i)=V(i)*cos(delta(i)); //Parte real de la tension
end 

k=0;condicion=1;
J=zeros(2*(n-1),2*(n-1));
P=zeros(n,1);
Q=zeros(n,1);

printf ("\n");
printf ("CALCULO DE FLUJO DE CARGA POR MEDIO DEL METODO NEWTON-RAPHSON\n\n");
printf ("Sistema de %d barras\n",n);

while (condicion==1)             //Incializacin del algoritmo de Newton Raphson mediante un ciclo
 P=zeros(n,1);
 Q=zeros(n,1);
 for i=1:n
  if (Tipo(i)<>1) then           //Clculo de las potencias activa y reactiva 
   for l=1:n                     //exceptuando el nodo de compensacin
    P(i)=V(i)*(V(l)*real(Y(i,l))+d(l)*(-1)*imag(Y(i,l)))+d(i)*(d(l)*real(Y(i,l))-V(l)*(-1)*imag(Y(i,l)))+P(i);
    Q(i)=d(i)*(V(l)*real(Y(i,l))+d(l)*(-1)*imag(Y(i,l)))-V(i)*(d(l)*real(Y(i,l))-V(l)*(-1)*imag(Y(i,l)))+Q(i);
   end
  end
 end
 
 for i=1:n
  if (Tipo(i)<>1) then           //Clculo de los cambios de potencia activa y reactiva por barra
   deltaP(i)=Pl(i)-P(i);         
   deltaQ(i)=Ql(i)-Q(i);
  end
 end
 
 deltaPmax=max(abs(deltaP));     //Clculo del cambio mximo de las potencias por iteracin
 deltaQmax=max(abs(deltaQ));
 
 if (deltaPmax<Epsilon & deltaQmax<Epsilon) then   //Verificacin de las condiciones de error
  condicion=0;                                     //mnimo de las potencias
 else
  
  for i=1:n                                        //Clculo de las corrientes de barra
   if (Tipo(i)<>1) then
    I(i)=(P(i)-j*Q(i))/conj(V(i)+j*d(i));
    c(i)=real(I(i));
    e(i)=imag(I(i));
   end
  end
  
  i=0;
  for p=1:n                                        //Clculo de la Matriz Jacobiana
   if (Tipo (p)<>1) then
    l=1;
    i=i+1;
    for q=1:n
     if (Tipo (q)<>1) then                         
      if (q<>p)
       J(i,l)=V(p)*real(Y(p,q))-d(p)*(-1)*imag(Y(p,q));
       J(i,l+(n-1))=V(p)*(-1)*imag(Y(p,q))+d(p)*real(Y(p,q));
       J(i+(n-1),l)=V(p)*(-1)*imag(Y(p,q))+d(p)*real(Y(p,q));
       J(i+(n-1),l+(n-1))=-V(p)*real(Y(p,q))-d(p)*(-1)*imag(Y(p,q));
       l=l+1;
      else
       J(i,l)=V(p)*real(Y(p,p))-d(p)*(-1)*imag(Y(p,p))+c(p);
       J(i,l+(n-1))=V(p)*(-1)*imag(Y(p,p))+d(p)*real(Y(p,p))+e(p);
       J(i+(n-1),l)=V(p)*(-1)*imag(Y(p,p))+d(p)*real(Y(p,p))-e(p);
       J(i+(n-1),l+(n-1))=-V(p)*real(Y(p,p))+d(p)*(-1)*imag(Y(p,p))+c(p);
       l=l+1;
      end
     end
    end
   end
  end 
  
  l=1;
  for i=1:n                             //Calculo de la matriz de diferencia de Potencias
   if (Tipo(i)<>1) then
    dPotencia(l)=deltaP(i);
    dPotencia(l+(n-1))=deltaQ(i);
    l=l+1;
   end
  end
  
  dTension=inv (J)*dPotencia;           //Calculo de las correcciones de tension
  
  l=1;
  for i=1:n                             //Calculo de las nuevas tensiones 
   if (Tipo(i)<>1) then
    V(i)=dTension(l)+V(i);
    d(i)=dTension(l+(n-1))+d(i);
    l=l+1;
   end
  end 
 end
 k=k+1;                                 //Avance del contador de iteraciones
end

for i=1:n                               //Clculo de las potencias activa y reactiva del sistema
 if (Tipo(i)==1) then                   //para la barra de compensacin
  for l=1:n
   P(i)=V(i)*(V(l)*real(Y(i,l))+d(l)*(-1)*imag(Y(i,l)))+d(i)*(d(l)*real(Y(i,l))-V(l)*(-1)*imag(Y(i,l)))+P(i);
   Q(i)=d(i)*(V(l)*real(Y(i,l))+d(l)*(-1)*imag(Y(i,l)))-V(i)*(d(l)*real(Y(i,l))-V(l)*(-1)*imag(Y(i,l)))+Q(i);
  end
 end
end

for i=1:n
 ang(i)=360*atan(d(i)/V(i))/(2*%pi);    
 V(i)=V(i)+j*d(i);
 if (Tipo(i)==1)
  Pg(i)=P(i);
  Qg(i)=Q(i);
 end 
end 


[Vmag,Vang]=escribir1 (n,V,Pg,Qg,Pd,Qd,k);
[activ,reactiv]=escribir2(n,V,Y,y,base,j);     //Invocacin de las funciones para la impresin,
[perd]=perdidas(n,Y,activ,base);               //graficacin y almacenamiento de los resultados
graficas(n,Vmag,Vang);
[arch]=archivo(n,Vmag,Vang,Pg,Qg,Pd,Qd);

mensaje='FIN DEL ANLISIS';
endfunction
 
